<template>
  <div style="margin-top:60px" class="content-grid content-grid--subpage">

    <BackLinkTitle :title="backLinkTitle"/>
    {{ nomCours }}

    <Card title="Grilles">
      <div>
        <el-button
            size="small"
            :icon="Plus"
            class="add-grille-btn"
            @click="handleDialog"
        >Grille
        </el-button
        >
        <el-button
            size="small"
            :icon="Plus"
            class="importer-grille-btn"
            @click="
            () => {
              router.push({
                name: t('routes.grilles.name'),
                params: { id: coursId },
              });
            }
          "
        >Importer Grille
        </el-button
        >
      </div>

      <DataTable
          :headers="grillesHeader"
          :items="tableGrilles"
          @delete="deleteGrille"
          @click="handleRowClick"
      />
    </Card>

    <Card v-if="etudiants.length > 0" :title="code" :title2="nomCours">
      <DataTable
          :headers="etudiantCoursHeader"
          :items="tableEtudiantCours"
          @delete="deleteEtudiantCoursWithId"
      />
      <button
          class="form__submit btn btn--red btn--fullscreen"
          @click="deleteStudents(coursId)"
      >
        {{ t("global.deleteStudents") }}
      </button>
    </Card>
    <Card v-else>
      <h2>{{ t("global.noEtudiants") }}</h2>

      <div class="content-grid">
        <label for="fileInput" class="drop-container">
          <span class="drop-title">{{
              t("global.importer.glisserFichier")
            }}</span>
          ou
          <input
              type="file"
              id="fileInput"
              class="form-files"
              v-on:change="importeHandler"
          />
        </label>

        <form class="form" novalidate @submit.prevent="handleSubmit">
          <RouterLink class="link" :to="t('routes.aide.path')">
            {{
              t("global.aide")
            }}
          </RouterLink>
          <button class="btn btn--fullscreen" type="submit">
            {{ t("global.importer.importation") }}
          </button>
        </form>
      </div>
    </Card>
  </div>
  <el-dialog v-model="dialogFormVisible" width="500px">
    <template #header>
      <el-text>Enregistrement grille</el-text>
    </template>
    <form
        class="form"
        novalidate
        @submit.prevent="handleSubmitCreateGrille"
        enctype="multipart/form-data"
    >
      <Fieldset>
        <FormRow>
          <FormInput
              v-model="grille.titre"
              type="text"
              name="Titre"
              ref="addFormInputRef"
              @validated="handleValidation"
          />
          <FormInput
              v-model="grille.ponderation"
              type="number"
              name="Ponderation"
              ref="addFormInputRef"
              @validated="handleValidation"
          />
        </FormRow>
      </Fieldset>
      <button class="form__submit btn btn--fullscreen" type="submit">
        {{ t("global.save") }}
      </button>
    </form>
  </el-dialog>
</template>

<script lang="ts" setup>
//#region imports
import {Plus} from "@element-plus/icons-vue";
import {ElNotification} from "element-plus";
import Card from "@/components/layout/Card.vue";
import {useI18n} from "vue3-i18n";
import DataTable from "@/components/layout/DataTable.vue";
import {Cours} from "@/types/entities/cours";
import {
  useCoursService,
  useEtudiantCoursService,
  useEtudiantService,
  useGrilleService,
} from "@/inversify.config";
import {useRoute, useRouter} from "vue-router";
import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
import {ref, onMounted, computed} from "vue";
import {notifyError, notifySuccess} from "@/notify";
import {EtudiantCours} from "@/types/entities/etudiantCours";
import {EtudiantGroupe} from "@/types/entities/etudiantGroupe";
import {Etud} from "@/types/requests/createAllEtudiantsRequest";
import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
import {Grille} from "../../types/entities/grille";
import {ICreateGrilleRequest} from "@/types/requests/createGrilleRequest";
import FormRow from "@/components/forms/FormRow.vue";
import FormInput from "@/components/forms/FormInput.vue";
import Fieldset from "@/components/forms/Fieldset.vue";
import {Status} from "@/validation";
//#endregion
//#region variables
const messRoutes = "Cours / Consultation des cours / Details du cours";
const backLinkTitle = "Détails du cours";
const {t} = useI18n();
const route = useRoute();
const coursService = useCoursService();
const etudiantsService = useEtudiantService();
const etudiantCoursService = useEtudiantCoursService();
const grilleService = useGrilleService();
const coursId = route.params.id.toString();
const router = useRouter();
const cours = ref<Cours>(await coursService.getCours(coursId));
const etudiants = ref<EtudiantCours[]>([]);
let etudiantsGroupe = ref<EtudiantGroupe[]>([]);
const code = cours.value.code;
const nomCours = cours.value.nomCours;
const grilles = ref<Grille[]>([]);
const grille = ref({
  titre: "",
  ponderation: 0,
  coursId: cours.value.id,
  element: [],
});
const tableGrilles = computed(() => {

  return grilles.value
      .map((x: Grille) => {
        return {
          id: x.id,
          titre: x.titre,
          ponderation: x.ponderation,
          actions: {
            update: {
              path: `/fr/cours/${coursId}/grille/${x.id}/modifier`,
              params: {id: x.id},
            },
            delete: true,
            view: {
              path: `/fr/cours/${coursId}/grille/${x.id}/utiliser`,
              params: {
                id: x.id,
              },
            }
          },
        };
      })
      .sort((a: any, b: any) => {
        if (a.name < b.name) {
          return -1;
        }
        if (a.name > b.name) {
          return 1;
        }
        return 0;
      }) as unknown as Grille[];
});
const tableEtudiantCours = computed(() => {
  return etudiants.value
      .map((x: EtudiantCours) => {
        return {
          id: x.id,
          da: x.etudiant.da,
          prenom: x.etudiant.prenom,
          nom: x.etudiant.nom,
          groupe: x.groupe,
          actions: {
            delete: true,
          },
        };
      })
      .sort((a: any, b: any) => {
        if (a.name < b.name) {
          return -1;
        }
        if (a.name > b.name) {
          return 1;
        }
        return 0;
      }) as unknown as EtudiantGroupe[];
});
//#endregion

//#region functions

const handleRowClick = (e: any) => {
  if (e.target.parentNode.getElementsByTagName('a')[0] !== undefined)
    e.target.parentNode.getElementsByTagName('a')[0].click()
}

async function deleteEtudiantCoursWithId(etudiantCours: EtudiantCours) {
  if (etudiantCours.id == null) return;
  let confirmation = confirm(t("validation.etudiantCours.delete.confirmation"));
  if (!confirmation) return;
  let response = await etudiantCoursService.DeleteEtudiantCoursWithId(
      etudiantCours.id
  );
  if (response.succeeded) {
    etudiants.value = etudiants.value.filter((x) => x.id !== etudiantCours.id);
    notifySuccess(t("validation.etudiantCours.delete.success"));
  } else {
    let errorMessages = response.getErrorMessages(
        "validation.etudiantCours.delete",
        "validation.etudiantCours.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
}

onMounted(async () => {
  grilles.value = await grilleService.getGrilleWithCoursId(cours.value.id!);
  etudiants.value = await etudiantCoursService.getAllGetAllEtudiantsByIdCours(
      coursId
  );
});
const dialogFormVisible = ref<boolean>(false);
const formInputs = ref<any[]>([]);
const inputValidationStatuses: any = {};

function addFormInputRef(ref: typeof FormInput) {
  if (!formInputs.value.includes(ref) && ref) formInputs.value.push(ref);
}

async function handleValidation(name: string, validationStatus: Status) {
  inputValidationStatuses[name] = validationStatus.valid;
}

async function handleSubmitCreateGrille() {
  formInputs.value.forEach((x: typeof FormInput) => x.validateInput());
  if (Object.values(inputValidationStatuses).some((x) => x === false)) {
    ElNotification.warning({
      title: "Attention!",
      message: `Remplissez tout les champs`,
      duration: 1500,
      showClose: false,
    });
    return
  } else {
    let succeededOrNotResponse = await grilleService.createGrille(
        grille.value as ICreateGrilleRequest
    );
    if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
      ElNotification.success({
        title: "Sauvegarde",
        message: "La grille a bien ete enregistre",
        duration: 1500,
        showClose: false,
      });
    } else {
      if (succeededOrNotResponse.errors.length == 0)
        ElNotification.error({
          title: "Erreur!",
          message: "Un erreur c'est produite",
          duration: 2000,
          showClose: false,
        });
      else
        ElNotification.error({
          title: "Erreur",
          message: succeededOrNotResponse.errors[0].errorMessage,
          duration: 2000,
          showClose: false,
        });
    }
    grilles.value = await grilleService.getGrilleWithCoursId(cours.value.id!);
    dialogFormVisible.value = false;
  }
}

const handleDialog = () => {
  dialogFormVisible.value = true;
};

const deleteGrille = async (pGrille: Grille) => {
  if (confirm("Voulez-vous vraiment supprimer cette grille?")) {
    if (pGrille.id == null) return;

    const response = await grilleService.deleteGrille(pGrille.id);

    if (response.errors.length === 0) {

      grilles.value = grilles.value.filter((x) => x.id !== pGrille.id);

      ElNotification.success({
        title: "Suppression grille",
        message: "grille supprimé avec succès!",
        showClose: false,
        duration: 1500
      })
    } else {

      ElNotification.error({
        title: "Suppression grille",
        message: "Une erreur s'est produite lors de la suppression",
        showClose: false,
        duration: 1500
      })
    }
  }

};

function importeHandler(event: Event) {
  const inputElement = event.target as HTMLInputElement;

  if (inputElement.files && inputElement.files.length > 0) {
    const file = inputElement.files[0];

    const fileReader = new FileReader();
    fileReader.onload = (event) => {
      const csvData = event.target?.result as string;
      const data = csvData
          .split("\n")
          .map((line) => line.trim().replace("\r", ""));

      etudiantsGroupe.value = data
          .filter((line) => line !== "")
          .map((line) => {
            const [Da, Groupe, Prenom, Nom] = line
                .split(";")
                .map((field) => field.replace(/^="|"$/g, ""));
            return {
              Da,
              Groupe,
              Prenom,
              Nom,
            } as EtudiantGroupe;
          });

      etudiantsGroupe.value.shift();
    };
    fileReader.readAsText(file);
  }

  return false;
}

async function handleSubmit() {
  if (etudiantsGroupe.value.length == 0) {
    notifyError("Veuillez choisir un fichier pour importer.");
    return;
  }
  let succeededOrNotResponse = await etudiantsService.createAllEtudiants(
      {
        Etudiants: etudiantsGroupe.value as Etud[],
      },
      coursId
  );
  if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
    notifySuccess(t("validation.etudiant.import.success"));
    // setTimeout(() => {
    //   router.back();
    // }, 1500);
    etudiants.value = etudiantsGroupe.value.map((x) => {
      return {
        etudiant: {
          da: x.Da,
          prenom: x.Prenom,
          nom: x.Nom,
        },
        groupe: x.Groupe,
      } as EtudiantCours;
    });
  } else {
    let errorMessages = succeededOrNotResponse.getErrorMessages(
        "validation.etudiant.import.errorOccured"
    );
    if (errorMessages.length == 0)
      notifyError(t("validation.etudiant.import.errorOccured"));
    else notifyError(errorMessages[0]);
  }
}

async function deleteStudents(coursId: string) {
  if (coursId == null) return;

  let confirmation = confirm(t("validation.etudiant.delete.confirmation"));
  if (!confirmation) return;

  let response = await etudiantCoursService.deleteStudentsWithCoursId(coursId);
  if (response.succeeded) {
    notifySuccess(t("validation.etudiant.delete.success"));
    etudiants.value = [];
  } else {
    let errorMessages = response.getErrorMessages(
        "validation.etudiant.delete",
        "validation.etudiant.delete.errorOccured"
    );
    notifyError(errorMessages[0]);
  }
}

//#endregion

//#region headers
const etudiantCoursHeader = [
  {
    text: "Da",
    value: "da",
    sortable: true,
    width: 200,
  },
  {
    text: "Prenom",
    value: "prenom",
    sortable: true,
    width: 150,
  },
  {
    text: "Nom",
    value: "nom",
    sortable: true,
    width: 150,
  },
  {
    text: "Groupe",
    value: "groupe",
    sortable: true,
    width: 150,
  },
  {
    text: "",
    value: "actions",
    width: 75,
  },
];

const grillesHeader = [
  {
    text: "Titre",
    value: "titre",
    sortable: true,
    width: 150,
  },
  {
    text: "Ponderation(%)",
    value: "ponderation",
    sortable: true,
    width: 100,
  },
  {
    text: "",
    value: "actions",
    width: 120,
  },
];
//#endregion
</script>

<style scoped>
.add-grille-btn {
  width: 75px;
}

.importer-grille-btn {
  width: 150px;
}

h2 {
  margin-bottom: 30px;
}

.drop-container {
  position: relative;
  display: flex;
  gap: 10px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  height: 200px;
  padding: 20px;
  border-radius: 10px;
  border: 2px dashed #555;
  color: #444;
  cursor: pointer;
  transition: background 0.2s ease-in-out, border 0.2s ease-in-out;
}

.add-grille-btn {
  width: 75px;
}

h2 {
  margin-bottom: 30px;
}

.drop-container {
  position: relative;
  display: flex;
  gap: 10px;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  height: 200px;
  padding: 20px;
  border-radius: 10px;
  border: 2px dashed #555;
  color: #444;
  cursor: pointer;
  transition: background 0.2s ease-in-out, border 0.2s ease-in-out;
}

.drop-container:hover {
  background: #eee;
  border-color: #111;
}

.drop-container:hover .drop-title {
  color: #222;
}

.drop-title {
  color: #444;
  font-size: 20px;
  font-weight: bold;
  text-align: center;
  transition: color 0.2s ease-in-out;
}

input[type="file"]::file-selector-button {
  margin-right: 20px;
  border: 1px solid #7ac142;
  background: #abefaa;
  padding: 10px 20px;
  border-radius: 10px;
  color: #000000;
  cursor: pointer;
  font-family: "Karla", "Helvetica Neue", Helvetica, arial, sans-serif;
  transition: background 0.2s ease-in-out;
  font-size: 1rem;
}

input[type="file"]::file-selector-button:hover {
  background: #529b2e;
}

.link {
  color: #61b521 !important;
  text-decoration: underline !important;
  display: block;
  text-align: center;
  margin-bottom: 15px;
}

.dialog-footer {
  display: flex;
  justify-content: flex-end;
  gap: 10px;
}

.dialog-footer button {
  padding: 10px 20px !important;
}
</style>
